<template>
  <div >
    <v-form  action="https://vuejs.org/" method="post">
      <v-container >
        <v-layout>
          <v-flex xs2 md4 >
            <v-text-field
                    v-model="firstName"
                    label="First Name"
                    :rules="nameRules"
                    required
            ></v-text-field>
          </v-flex>

          <v-flex xs2 md4>
            <v-text-field
                    v-model="lastName"
                    label="Last Name"
                    :rules="nameRules"
                    required
            ></v-text-field>
          </v-flex>
          <v-flex xs12 md4>
            <v-text-field
                    v-model="username"
                    label="User NAme"
                    :rules="nameRules"
                    required
            ></v-text-field>
          </v-flex>
          <v-flex xs12 md4>
            <v-text-field
                    v-model="password"
                    label="Password"
                    type="password"
                    :rules="nameRules"

                    required
            ></v-text-field>
          </v-flex>
          <v-flex xs12 md4>
            <v-text-field
                    v-model="password2"
                    label="Confirm your password"
                    type="password"
                    :rules="nameRules"
                    required
            ></v-text-field>
          </v-flex>
          <v-flex xs12 md4>
            <v-text-field
                    v-model="email"
                    label="Email"
                    type="email"
                    :rules="emailRules"
                    required
            ></v-text-field>
          </v-flex>
        </v-layout>
      </v-container>
      <v-btn v-on:click="submit" color="#FDFEFE">Submit</v-btn>
    </v-form>
    <p v-if="!formValid">Form not valid</p>

  </div>

</template>

<script>
import axios from "axios";

const userUrl = `${process.env.VUE_APP_API_URL}/users`;

export default {
  name: "FormInscription",
  data() {
    return {
      emailRules: [
        v => !!v || 'E-mail is required',
        v => /.+@.+/.test(v) || 'E-mail must be valid'
      ],
      nameRules: [
        v => !!v || 'Name is required',
        v => (v && v.length <= 10) || 'Name must be less than 10 characters'
      ],
      firstName: "",
      lastName: "",
      username: "",
      password: "",
      password2: "",
      email: ""
    };
  },
  computed: {
    formValid() {
      return this.validateForm();
    }
  },
  methods: {
    validateForm() {
      let isValid = true;
      isValid &= this.password === this.password2;
      isValid &= this.firstName !== "";
      isValid &= this.username !== "";
      isValid &= this.password !== "";
      isValid &= this.email !== "";
      return isValid;
    },
    submit() {
      console.log(userUrl);
      if (this.formValid) {
        axios
          .post(userUrl, {
            username: this.username,
            password: this.password,
            firstName: this.firstName,
            lastName: this.lastName,
            email: this.email
          })
          .then(
            function(response) {
              if (response.status === 200) {
                console.log(response);
                console.log("Bien enregistré");
              }
            },
            function(err) {
              console.error(err);
            }
          );
      }
    }
  }
};
</script>

<style scoped></style>
